## gm-assistant 1.2.3

=== CMakeLists.txt ===
#*************************************************************************
# Copyright © 2017-2020 Vincent Prat
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#************************************************************************

cmake_minimum_required (VERSION 3.1)

# project information
set (PROJECT_NAME GM-Assistant)
project (${PROJECT_NAME})

# handling version
set (VERSION_MAJOR 1)
set (VERSION_MINOR 2)
set (VERSION_PATCH 3)
configure_file(sources/engine/Version.h.in Version.h)

# options
set (CMAKE_INCLUDE_CURRENT_DIR ON)
set (CMAKE_AUTOMOC ON)
set (CMAKE_AUTORCC ON)
set (CMAKE_AUTOUIC ON)

# source directory
include_directories(
    sources/engine
    sources/engine/items
    sources/engine/modifications
    sources/misc
    sources/widgets
    sources/windows)
set (PROJECT_SOURCES
    ressource.qrc
    sources/main.cpp
    sources/engine/Branch.cpp
    sources/engine/Character.cpp
    sources/engine/CharacterList.cpp
    sources/engine/FileMapping.cpp
    sources/engine/IOConfig.cpp
    sources/engine/Metadata.cpp
    sources/engine/PropertyList.cpp
    sources/engine/Scenario.cpp
    sources/engine/Tree.cpp
    sources/engine/Version.cpp
    sources/engine/items/FileItem.cpp
    sources/engine/items/ImageItem.cpp
    sources/engine/items/Item.cpp
    sources/engine/items/ItemFactory.cpp
    sources/engine/items/SoundItem.cpp
    sources/engine/modifications/CharacterModification.cpp
    sources/engine/modifications/MetadataModification.cpp
    sources/engine/modifications/Modification.cpp
    sources/engine/modifications/ModificationQueue.cpp
    sources/engine/modifications/NoteModification.cpp
    sources/engine/modifications/TreeModification.cpp
    sources/widgets/QCustomHeaderView.cpp
    sources/widgets/QCustomTableWidget.cpp
    sources/widgets/QCustomTextEdit.cpp
    sources/widgets/QCustomTreeWidget.cpp
    sources/widgets/QCustomTreeWidgetItem.cpp
    sources/windows/AboutDialog.cpp
    sources/windows/ChangeCharacterDialog.cpp
    sources/windows/ChangePropertyDialog.cpp
    sources/windows/CombatDialog.cpp
    sources/windows/DiceDialog.cpp
    sources/windows/ImageWindow.cpp
    sources/windows/ItemDialog.cpp
    sources/windows/MainWindow.cpp
    sources/windows/MetadataDialog.cpp
    sources/windows/SelectCharacterDialog.cpp)
set (PROJECT_FORMS
    sources/windows/AboutDialog.ui
    sources/windows/ChangeCharacterDialog.ui
    sources/windows/ChangePropertyDialog.ui
    sources/windows/CombatDialog.ui
    sources/windows/DiceDialog.ui
    sources/windows/ItemDialog.ui
    sources/windows/MainWindow.ui
    sources/windows/MetadataDialog.ui
    sources/windows/SelectCharacterDialog.ui)

# find libraries
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5Multimedia REQUIRED)

# Poco
find_path(POCO_INCLUDE_DIR
    NAMES Poco.h
    PATH_SUFFIXES Poco)
if (${POCO_INCLUDE_DIR} STREQUAL POCO_INCLUDE_DIR-NOTFOUND)
    message(FATAL_ERROR "Could not find Poco.h.")
endif()
find_library(POCO_LIBRARY
    NAMES PocoFoundation)
if (${POCO_LIBRARY} STREQUAL POCO_LIBRARY-NOTFOUND)
    message(FATAL_ERROR "Could not find PocoFoundation library.")
endif()
find_library(POCOZIP_LIBRARY
    NAMES PocoZip)
if (${POCOZIP_LIBRARY} STREQUAL POCOZIP_LIBRARY-NOTFOUND)
    message(FATAL_ERROR "Could not find PocoZip library.")
endif()
find_library(POCOXML_LIBRARY
    NAMES PocoXML)
if (${POCOXML_LIBRARY} STREQUAL POCOXML_LIBRARY-NOTFOUND)
    message(FATAL_ERROR "Could not find PocoXML library.")
endif()

include_directories(
    ${POCO_INCLUDE_DIR})

# linguist tools
find_package(Qt5LinguistTools)
if (${Qt5LinguistTools_FOUND})
    # ts -> qm
    set (TRANSLATION_FILES
        translations/gmassistant_fr.ts
        translations/gmassistant_it.ts)
    qt5_add_translation(TRANSLATION_QM
        ${TRANSLATION_FILES})

    # update of ts
    add_custom_target(update
        COMMAND ${Qt5_LUPDATE_EXECUTABLE} -no-obsolete ${PROJECT_SOURCES} ${PROJECT_FORMS} -ts ${TRANSLATION_FILES}
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        COMMENT "Updating translation files"
        VERBATIM)
else()
    set (TRANSLATION_QM)
endif()

# executable
set (EXEC_NAME gm-assistant)
add_executable(${EXEC_NAME}
    ${PROJECT_SOURCES}
    ${TRANSLATION_QM})

# link libraries
target_link_libraries(${EXEC_NAME}
    Qt5::Widgets
    Qt5::Svg
    Qt5::Multimedia
    ${POCO_LIBRARY}
    ${POCOZIP_LIBRARY}
    ${POCOXML_LIBRARY})

# installation
set (BIN_DIR games)
set (DATA_DIR share/games/${EXEC_NAME})
set (DOC_DIR share/doc/${EXEC_NAME})
set (MAN_DIR share/man)

install(TARGETS ${EXEC_NAME}
    DESTINATION ${BIN_DIR})
install(FILES data/images/GMA.svg
    DESTINATION ${DATA_DIR})
install(FILES ${TRANSLATION_QM} translations/languages
    DESTINATION ${DATA_DIR}/translations)
install(FILES doc/gm-assistant.6
    DESTINATION ${MAN_DIR}/man6)

# desktop file
set (DESKTOP_FILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/${EXEC_NAME}.desktop.in)
set (DESKTOP_FILE ${CMAKE_CURRENT_BINARY_DIR}/${EXEC_NAME}.desktop)
configure_file(${DESKTOP_FILE_IN} ${DESKTOP_FILE})

install(FILES ${DESKTOP_FILE}
    DESTINATION share/applications)

# API documentation with Doxygen
find_package(Doxygen)
option(BUILD_API_DOC "Create the HTML-based API documentation (requires Doxygen)" ${DOXYGEN_FOUND})

if (${BUILD_API_DOC})
    if (NOT ${DOXYGEN_FOUND})
        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
    endif()

    set (doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/dox.conf.in)
    set (doxyfile ${CMAKE_CURRENT_BINARY_DIR}/dox.conf)

    configure_file(${doxyfile_in} ${doxyfile})

    add_custom_target(api
        COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile}
        COMMENT "Generating API documentation with Doxygen"
        VERBATIM)
endif()

# user guide with LATEX
find_package(LATEX COMPONENTS PDFLATEX)
option(BUILD_USERGUIDE "Build and install the PDF-based user guide (requires PDFLaTeX)" ${LATEX_PDFLATEX_FOUND})

if (${BUILD_USERGUIDE})
    if (NOT ${LATEX_PDFLATEX_FOUND})
        message(FATAL_ERROR "pdflatex is needed to build the user guide.")
    endif()

    # list of PDF files to build
    set (LIST_PDF)
    foreach (LANG en fr)
        set (TARGET_NAME userguide_${LANG}.pdf)
        set (TEXFILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/userguide_${LANG}.tex)
        set (TEX_PATH ${CMAKE_CURRENT_SOURCE_DIR}/doc/userguide/${LANG})

        configure_file(${TEX_PATH}/userguide.tex.in ${TEXFILE_NAME})
        list (APPEND LIST_PDF ${TARGET_NAME})

        add_custom_command(OUTPUT ${TARGET_NAME}
            COMMAND ${PDFLATEX_COMPILER} ${TEXFILE_NAME} > /dev/null
            COMMAND ${PDFLATEX_COMPILER} ${TEXFILE_NAME} > /dev/null
            COMMAND ${PDFLATEX_COMPILER} ${TEXFILE_NAME} > /dev/null
            MAIN_DEPENDENCY ${TEXFILE_NAME}
            COMMENT "Generating user guide: ${LANG}"
            VERBATIM)

        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME} DESTINATION ${DOC_DIR})
    endforeach()

    add_custom_target(userguide
        ALL
        DEPENDS ${LIST_PDF})
endif()

=== debian/changelog ===
gm-assistant (1.2.3-2) unstable; urgency=medium

  * Source-only upload to enable migration

 -- Vincent Prat <vivi@debian.org>  Wed, 21 Oct 2020 20:17:40 +0200

gm-assistant (1.2.3-1) unstable; urgency=medium

  * Initial release. (Closes: #662985)

 -- Vincent Prat <vivi@debian.org>  Fri, 14 Aug 2020 20:34:01 +0200

=== debian/control ===
Source: gm-assistant
Section: games
Priority: optional
Maintainer: Vincent Prat <vivi@debian.org>
Build-Depends: cmake,
               debhelper (>= 13),
               debhelper-compat (= 13),
               latex2html,
               libpoco-dev,
               libqt5svg5-dev,
               lmodern,
               qtmultimedia5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               texlive-fonts-recommended,
               texlive-lang-french,
               texlive-latex-base,
               texlive-latex-recommended
Standards-Version: 4.5.0
Homepage: http://gmassistant.free.fr
Vcs-Browser: https://salsa.debian.org/vivi/gm-assistant
Vcs-Git: https://salsa.debian.org/vivi/gm-assistant.git
Rules-Requires-Root: no

Package: gm-assistant
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Game Master assistant for role-playing games
 GM-Assistant is designed to be the perfect assistant for the Game Master
 during tabletop role-playing games.
 .
 GM-Assistant enables to build structured scenarii with history and character
 table before the game, and to take notes, play music or sound effects, and
 display pictures during the game.
 It also includes a dice simulator and a combat manager.

Package: gm-assistant-doc
Section: doc
Architecture: all
Suggests: gm-assistant (= ${binary:Version})
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Game Master assistant for role-playing games - user guide
 GM-Assistant is designed to be the perfect assistant for the Game Master
 during tabletop role-playing games.
 .
 GM-Assistant enables to build structured scenarii with history and character
 table before the game, and to take notes, play music or sound effects, and
 display pictures during the game.
 It also includes a dice simulator and a combat manager.
 .
 This package contains the user guide.

=== debian/watch ===
version=4
https://github.com/ViviCoder/GM-Assistant/tags/ \
  /ViviCoder/GM-Assistant/archive/([\d\.]+).tar.gz

## gm-assistant 1.2.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #*************************************************************************
-# Copyright © 2017-2020 Vincent Prat
+# Copyright © 2017-2022 Vincent Prat & Simon Nicolas
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,7 +25,7 @@
 # handling version
 set (VERSION_MAJOR 1)
 set (VERSION_MINOR 2)
-set (VERSION_PATCH 3)
+set (VERSION_PATCH 4)
 configure_file(sources/engine/Version.h.in Version.h)
 
 # options
@@ -143,11 +143,19 @@
     set (TRANSLATION_QM)
 endif()
 
+if (WIN32)
+    set (RCFILE GMA.rc)
+endif()
+
 # executable
 set (EXEC_NAME gm-assistant)
 add_executable(${EXEC_NAME}
     ${PROJECT_SOURCES}
     ${TRANSLATION_QM})
+
+if (WIN32)
+    target_link_options(${EXEC_NAME} PRIVATE -mwindows)
+endif()
 
 # link libraries
 target_link_libraries(${EXEC_NAME}
@@ -168,14 +176,25 @@
     DESTINATION ${BIN_DIR})
 install(FILES data/images/GMA.svg
     DESTINATION ${DATA_DIR})
-install(FILES ${TRANSLATION_QM} translations/languages
-    DESTINATION ${DATA_DIR}/translations)
+if (${Qt5LinguistTools_FOUND})
+    install(FILES ${TRANSLATION_QM} translations/languages
+        DESTINATION ${DATA_DIR}/translations)
+endif()
 install(FILES doc/gm-assistant.6
     DESTINATION ${MAN_DIR}/man6)
 
+# metainfo file
+set (METAINFO_ID fr.free.gmassistant)
+set (METAINFO_FILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/${METAINFO_ID}.metainfo.xml.in)
+set (METAINFO_FILE ${CMAKE_CURRENT_BINARY_DIR}/${METAINFO_ID}.metainfo.xml)
+configure_file(${METAINFO_FILE_IN} ${METAINFO_FILE})
+
+install(FILES ${METAINFO_FILE}
+    DESTINATION share/metainfo)
+
 # desktop file
-set (DESKTOP_FILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/${EXEC_NAME}.desktop.in)
-set (DESKTOP_FILE ${CMAKE_CURRENT_BINARY_DIR}/${EXEC_NAME}.desktop)
+set (DESKTOP_FILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/${METAINFO_ID}.desktop.in)
+set (DESKTOP_FILE ${CMAKE_CURRENT_BINARY_DIR}/${METAINFO_ID}.desktop)
 configure_file(${DESKTOP_FILE_IN} ${DESKTOP_FILE})
 
 install(FILES ${DESKTOP_FILE}
@@ -202,36 +221,100 @@
 endif()
 
 # user guide with LATEX
-find_package(LATEX COMPONENTS PDFLATEX)
-option(BUILD_USERGUIDE "Build and install the PDF-based user guide (requires PDFLaTeX)" ${LATEX_PDFLATEX_FOUND})
-
-if (${BUILD_USERGUIDE})
+find_package(LATEX COMPONENTS PDFLATEX LATEX2HTML)
+option(BUILD_USERGUIDE_PDF "Build and install the user guide in PDF format (requires PDFLaTeX)" ${LATEX_PDFLATEX_FOUND})
+option(BUILD_USERGUIDE_HTML "Build and install the user guide in HTML format (requires LaTeX2HTML)" ${LATEX_LATEX2HTML_FOUND})
+
+if (${BUILD_USERGUIDE_PDF})
     if (NOT ${LATEX_PDFLATEX_FOUND})
-        message(FATAL_ERROR "pdflatex is needed to build the user guide.")
+        message(FATAL_ERROR "pdflatex is needed to build the user guide in PDF format.")
     endif()
+
+    set (PDFLATEX_OPTIONS -halt-on-error -interaction=nonstopmode)
 
     # list of PDF files to build
     set (LIST_PDF)
+endif()
+
+if (${BUILD_USERGUIDE_HTML})
+    if (NOT ${LATEX_LATEX2HTML_FOUND})
+        message(FATAL_ERROR "latex2html is needed to build the user guide in HTML format.")
+    endif()
+
+    set (LATEX2HTML_OPTIONS -verbosity 0 -show_section_numbers -info 0 -no_auto_link)
+
+    # list of HTML
+    set (LIST_HTML)
+else()
+    # removes html.sty from the preamble
+    set (HTML_STY "\\newcommand{\\latex}[1]{#1}%")
+endif()
+
+if (${BUILD_USERGUIDE_PDF} OR ${BUILD_USERGUIDE_HTML})
     foreach (LANG en fr)
-        set (TARGET_NAME userguide_${LANG}.pdf)
         set (TEXFILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/userguide_${LANG}.tex)
         set (TEX_PATH ${CMAKE_CURRENT_SOURCE_DIR}/doc/userguide/${LANG})
 
         configure_file(${TEX_PATH}/userguide.tex.in ${TEXFILE_NAME})
-        list (APPEND LIST_PDF ${TARGET_NAME})
-
-        add_custom_command(OUTPUT ${TARGET_NAME}
-            COMMAND ${PDFLATEX_COMPILER} ${TEXFILE_NAME} > /dev/null
-            COMMAND ${PDFLATEX_COMPILER} ${TEXFILE_NAME} > /dev/null
-            COMMAND ${PDFLATEX_COMPILER} ${TEXFILE_NAME} > /dev/null
-            MAIN_DEPENDENCY ${TEXFILE_NAME}
-            COMMENT "Generating user guide: ${LANG}"
-            VERBATIM)
-
-        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME} DESTINATION ${DOC_DIR})
+
+        if (${BUILD_USERGUIDE_PDF})
+            set (TARGET_NAME userguide_${LANG}.pdf)
+            list (APPEND LIST_PDF ${TARGET_NAME})
+
+            add_custom_command(OUTPUT ${TARGET_NAME}
+                COMMAND ${PDFLATEX_COMPILER} ${PDFLATEX_OPTIONS} ${TEXFILE_NAME}
+                COMMAND ${PDFLATEX_COMPILER} ${PDFLATEX_OPTIONS} ${TEXFILE_NAME} > /dev/null
+                COMMAND ${PDFLATEX_COMPILER} ${PDFLATEX_OPTIONS} ${TEXFILE_NAME} > /dev/null
+                MAIN_DEPENDENCY ${TEXFILE_NAME}
+                COMMENT "Generating PDF user guide: ${LANG}"
+                VERBATIM)
+
+            install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}
+                DESTINATION ${DOC_DIR}/pdf)
+        endif()
+
+        if (${BUILD_USERGUIDE_HTML})
+            set (DIR_NAME userguide_${LANG})
+            set (TARGET_NAME ${DIR_NAME}/index.html)
+            list (APPEND LIST_HTML ${TARGET_NAME})
+            string(TOUPPER ${LANG} LANG_UPPER)
+
+            add_custom_command(OUTPUT ${TARGET_NAME}
+                COMMAND ${LATEX2HTML_CONVERTER} ${LATEX2HTML_OPTIONS} -iso_language ${LANG_UPPER} ${TEXFILE_NAME} > /dev/null
+                MAIN_DEPENDENCY ${TEXFILE_NAME}
+                COMMENT "Generating HTML user guide: ${LANG}"
+                VERBATIM)
+
+            install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${DIR_NAME}
+                DESTINATION ${DOC_DIR}/html
+                FILES_MATCHING
+                PATTERN "*.html"
+                PATTERN "*.png")
+        endif()
     endforeach()
-
+endif()
+
+# generate generic targets
+set (TARGETS_ALL)
+
+if (${BUILD_USERGUIDE_PDF})
+    set (TARGET_PDF userguide_pdf)
+    add_custom_target(${TARGET_PDF}
+        ALL
+        DEPENDS ${LIST_PDF})
+    list (APPEND TARGETS_ALL ${TARGET_PDF})
+endif()
+
+if (${BUILD_USERGUIDE_HTML})
+    set (TARGET_HTML userguide_html)
+    add_custom_target(${TARGET_HTML}
+        ALL
+        DEPENDS ${LIST_HTML})
+    list (APPEND TARGETS_ALL ${TARGET_HTML})
+endif()
+
+if (TARGETS_ALL)
     add_custom_target(userguide
         ALL
-        DEPENDS ${LIST_PDF})
-endif()
+        DEPENDS ${TARGETS_ALL})
+endif()

=== debian/changelog ===
gm-assistant (1.2.4-1build3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 12 Apr 2024 05:21:47 +0000

gm-assistant (1.2.4-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:01:11 +0000

gm-assistant (1.2.4-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:29:22 +0000

gm-assistant (1.2.4-1) unstable; urgency=medium

  * New upstream release
  * Drop obsolete patches
  * Update d/copyright
  * Include HTML documentation
  * Recommends libqt5multimedia5-plugins

 -- Vincent Prat <vivi@debian.org>  Wed, 02 Mar 2022 20:42:26 +0100

gm-assistant (1.2.3-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Mark debian/rules as executable.
  * Set field Upstream-Name in debian/copyright.
  * Set upstream metadata fields: Bug-Submit.
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).

 -- Vincent Prat <vivi@debian.org>  Sat, 18 Sep 2021 12:27:55 +0200

gm-assistant (1.2.3-3) unstable; urgency=medium

  * Fix d/watch
  * Update Standards-Version to 4.6.0. No change needed.

 -- Vincent Prat <vivi@debian.org>  Sat, 21 Aug 2021 14:44:12 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: gm-assistant
 Section: games
 Priority: optional
-Maintainer: Vincent Prat <vivi@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Vincent Prat <vivi@debian.org>
 Build-Depends: cmake,
                debhelper (>= 13),
                debhelper-compat (= 13),
@@ -16,7 +17,7 @@
                texlive-lang-french,
                texlive-latex-base,
                texlive-latex-recommended
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: http://gmassistant.free.fr
 Vcs-Browser: https://salsa.debian.org/vivi/gm-assistant
 Vcs-Git: https://salsa.debian.org/vivi/gm-assistant.git
@@ -26,6 +27,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Recommends: libqt5multimedia5-plugins
 Description: Game Master assistant for role-playing games
  GM-Assistant is designed to be the perfect assistant for the Game Master
  during tabletop role-playing games.
